/***********************************************************************/
/*                                                                     */
/*                         C_data_user_long_double.c                   */
/*                                                                     */
/*  simple definition of a type corresponding to a standard C type     */
/*                                                                     */
/*  authors: D. Gaffe and A. Ressouche                                 */
/*                                                                     */
/*  version: 15/05/2022                                                */
/***********************************************************************/

#include <math.h>
#include "C_data_user_long_double.h"

#define C_DATA_USER_LONG_DOUBLE_EPSILON 0.000000000000000000000000000000000001L

const long_double zero_long_double=0.0L;

long_double copy_long_double(long_double x)
{
  return x;
}

long_double add_long_double(long_double x,long_double y)
{
  return x + y;
}

long_double sub_long_double(long_double x,long_double y)
{
  return x - y;
}
long_double neg_long_double(long double x)
{
  return x * (-1.0);
}

long_double mult_long_double(long_double x,long_double y)
{
  return x * y;
}

long_double div_long_double(long_double x,long_double y)
{
  return x / y;
}

int eq_long_double(long_double x,long_double y)
{
  return fabsl(x-y) < C_DATA_USER_LONG_DOUBLE_EPSILON;
}

int neq_long_double(long_double x,long_double y)
{
  return fabsl(x-y) >= C_DATA_USER_LONG_DOUBLE_EPSILON;
}

int less_long_double(long_double x,long_double y)
{
  return x < y;
}

int lesseq_long_double(long_double x,long_double y)
{
  return (x < y) || (fabsl(x-y) < C_DATA_USER_LONG_DOUBLE_EPSILON);
}

int sup_long_double(long_double x,long_double y)
{
  return x > y;
}

int supeq_long_double(long_double x,long_double y)
{
  return (x> y) || (fabsl(x-y) < C_DATA_USER_LONG_DOUBLE_EPSILON);
}
